package example.hw;

/**
 * Interface definition : Service
 * 
 * @author OpenORB Compiler
 */
public class ServicePOATie extends ServicePOA
{

    //
    // Private reference to implementation object
    //
    private ServiceOperations _tie;

    //
    // Private reference to POA
    //
    private org.omg.PortableServer.POA _poa;

    /**
     * Constructor
     */
    public ServicePOATie(ServiceOperations tieObject)
    {
        _tie = tieObject;
    }

    /**
     * Constructor
     */
    public ServicePOATie(ServiceOperations tieObject, org.omg.PortableServer.POA poa)
    {
        _tie = tieObject;
        _poa = poa;
    }

    /**
     * Get the delegate
     */
    public ServiceOperations _delegate()
    {
        return _tie;
    }

    /**
     * Set the delegate
     */
    public void _delegate(ServiceOperations delegate_)
    {
        _tie = delegate_;
    }

    /**
     * _default_POA method
     */
    public org.omg.PortableServer.POA _default_POA()
    {
        if (_poa != null)
            return _poa;
        else
            return super._default_POA();
    }

    /**
     * Operation print
     */
    public void print(String msg)
    {
        _tie.print( msg);
    }

}
